﻿;10.06.2024 start code
;11.06.2024 4:21 drag'n'drop
;16.06.2024 4:51 new icon, correct name if file exists
Enumeration
  #pa
EndEnumeration

Structure ICONDIRENTRY
  bWidth.a       ; Width, in pixels, of the image
  bHeight.a      ; Height, in pixels, of the image
  bColorCount.a  ; Number of colors in image (0 if >=8bpp)
  bReserved.a    ; Reserved ( must be 0)
  wPlanes.w      ; Color Planes
  wBitCount.w    ; Bits per pixel
  dwBytesInRes.l ; How many bytes in this resource?
  dwImageOffset.l; Where in the file is this image?
EndStructure


Procedure dodrop(df$)
  dropn=CountString(df$,Chr($0A))
  amem=6
  numicons.u=0
  sp$=""
  For i=0 To dropn
    f$=StringField(df$,i+1,Chr($0A))
    If sp$=""
      sp$=f$
    EndIf
    If FileSize(f$)>0
      If ReadFile(0,f$)
        amem=amem+FileSize(f$)-6
        w1.w=ReadWord(0) ; must be 0
        w2.w=ReadWord(0) ; must be 1
        w3.w=ReadWord(0) ; # of icons
        CloseFile(0)
        If w1<>0 And w2<>1
          MessageRequester("Not .ico file",f$)
          amem=0
          Break
        Else
          If w3
            numicons=numicons+w3
          Else
            MessageRequester("Wrong number of icons="+Str(w3),f$)
            amem=0
            Break
          EndIf;if w3
        EndIf  ;If w1<>0 And w2<>1
      Else
        MessageRequester("Error read file",f$)
      EndIf
    Else
      amem=0
      MessageRequester("Bad file",f$)
      Break
    EndIf
  Next i
  If amem
    *m=AllocateMemory(amem)
    PokeU(*m,0)
    PokeU(*m+2,1)
    PokeU(*m+4,numicons)
    *p=*m+6
    *d=*m+6+numicons*SizeOf(ICONDIRENTRY)
    If *m
      canwrite=1
      For i=0 To dropn
        f$=StringField(df$,i+1,Chr($0A))
        If ReadFile(0,f$)
          w1.w=ReadWord(0) ; must be 0
          w2.w=ReadWord(0) ; must be 1
          w3.w=ReadWord(0) ; # of icons
          ReadData(0,*p,SizeOf(ICONDIRENTRY)*w3)
          For k=0 To w3-1
            bpi=PeekL(*p+k*SizeOf(ICONDIRENTRY)+8)
            ReadData(0,*d,bpi)
            ;            PokeL(*m+6+i*SizeOf(ICONDIRENTRY)+12,*d-*m);image offset
            PokeL(*p+k*SizeOf(ICONDIRENTRY)+12,*d-*m);image offset
            *d=*d+bpi
          Next k
          CloseFile(0)
          *p=*p+SizeOf(ICONDIRENTRY)*w3
        Else
          MessageRequester("Error read file",f$)
          canwrite=0
          Break
        EndIf
      Next i
      
      If canwrite
        ;--prompt file
        ;StandardFile$ = "C:\autoexec.bat"   ; set initial file+path to display
        Pattern$ = "Icon files (*.ico)|*.ico"
        File$ = SaveFileRequester("Please choose file to save", sp$, Pattern$, 0)
        If File$
          If LCase(Right(File$,3))<>"ico"
            File$=File$+".ico"
          EndIf
;--check dupes 
          While FileSize(File$)>0
            ;Debug LCase(Right(File$,3))
            If LCase(Right(File$,3))="ico"
              File$=InsertString(File$,"~",Len(File$)-3)
            Else
              File$+"~"
            EndIf
          Wend
          If CreateFile(0,File$)
            WriteData(0,*m,amem)
            CloseFile(0)
          Else
            MessageRequester("Write file error",File$)
          EndIf
        EndIf;If file$
      EndIf  ;If canwrite
      FreeMemory(*m)
    Else
      MessageRequester("Memory Error","Cannot allocate memory")
    EndIf;If *m
  EndIf  ;If amem
EndProcedure

;some tests
;dodrop("regexp01_16x16.ico"+Chr(10)+"regexp01_32x32.ico")
;dodrop("hujcy.ico"+Chr(10)+"wrench02.ico")
;dodrop("Circles46_16x16.ico"+Chr(10)+"Circles46_32x32.ico")
;dodrop("wrench02_16.ico"+Chr(10)+"wrench02_32.ico"+Chr(10)+"wrench02_128.ico")
If OpenWindow(0, 0, 0, 640, 480, "IconCombine by g0blinish", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  FrameGadget(#pa, 0, 0, 640, 480, "Drop files to window")
  EnableGadgetDrop(#pa,#PB_Drop_Files,#PB_Drag_Copy)
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select event
      Case #PB_Event_GadgetDrop
        dodrop(EventDropFiles())
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 1
        EndSelect
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 124
; FirstLine = 111
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = icomb.ico
; Executable = icomb.exe